# Yahoo! UI Library

### datatable 3.3.0

Yahoo! UI Library > datatable > DataTableDataSource
Search:
Filters Show Private Show Protected Show Deprecated

## Class DataTableDataSource - extends Plugin.Base

Adds DataSource integration to DataTable.

### Properties

#### NAME - `static final String`

Class name.

#### NS - `static final String`

The namespace for the plugin. This will be the property on the host which references the plugin instance.

#### Properties inherited from Plugin.Host:

`PluginHost`

#### Properties inherited from Attribute:

``

#### Properties inherited from Base:

`name`

#### Properties inherited from Plugin.Base:

`_handles`

### Methods

#### _setDataSource

`private void _setDataSource ( ds )`
Creates new DataSource instance if one is not provided.

Parameters:
  `ds <Object | Y.DataSource>`

#### _setInitialRequest

`private void _setInitialRequest ( request )`
Sends request to DataSource.

Parameters:
  `request <Object>` DataSource request.

#### initializer

`private void initializer ( config )`
Initializer.

Parameters:
  `config <Object>` Config object.

#### load

`void load ( config )`
Load data by calling DataSource's sendRequest() method under the hood.

Parameters:
  `config <object>` Optional configuration parameters:
  request
    Pass in a new request, or initialRequest is used.
  callback
    Pass in DataSource callback object, or the following default is used:
    success
      datatable.onDataReturnInitializeTable
    failure
      datatable.onDataReturnInitializeTable
    scope
      datatable
    argument
      datatable.getState()
  datasource
    Pass in a new DataSource instance to override the current DataSource for this transaction.

#### onDataReturnInitializeTable

`void onDataReturnInitializeTable ( e )`
Callback function passed to DataSource's sendRequest() method populates an entire DataTable with new data, clearing previous data, if any.

Parameters:
  `e <Event.Facade>` DataSource Event Facade object.

#### Methods inherited from EventTarget:

`_getType, _monitor, _parseType, addTarget, after, before, bubble, detach, detachAll, fire, getEvent, getTargets, on, once, parseType, publish, removeTarget, subscribe, unsubscribe, unsubscribeAll`

#### Methods inherited from Attribute:

`_addAttrs, _addLazyAttr, _defAttrChangeFn, _fireAttrChange, _getAttr, _getAttrCfg, _getAttrInitVal, _getAttrs, _getStateVal, _isLazyAttr, _normAttrVals, _protectAttrs, _set, _setAttr, _setAttrs, _setAttrVal, _setStateVal, addAttr, addAttrs, attrAdded, get, getAttrs, modifyAttr, removeAttr, reset, set, setAttrs`

#### Methods inherited from Plugin.Host:

`_destroyPlugins, _initPlugins, hasPlugin, plug, unplug`

#### Methods inherited from Base:

`_aggregateAttrs, _defDestroyFn, _defInitFn, _destroyHierarchy, _filterAttrCfs, _getAttrCfgs, _getClasses, _initHierarchy, _initHierarchyData, _preInitEventCfg, destroy, init, toString`

#### Methods inherited from Plugin.Base:

`afterHostEvent, afterHostMethod, beforeHostMethod, destructor, doAfter, doBefore, initializer, onHostEvent`

### Events

#### datasourceChange

`datasourceChange ( event )`
Fires when the value for the configuration attribute 'datasource' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### initialRequestChange

`initialRequestChange ( event )`
Fires when the value for the configuration attribute 'initialRequest' is changed. You can listen for the event using the on method if you wish to be notified before the attribute's value has changed, or using the after method if you wish to be notified after the attribute's value has changed.

Parameters:
  `event <Event.Facade>` An Event Facade object with the following attribute specific properties added:
  prevVal
    The value of the attribute, prior to it being set
  newVal
    The value the attribute is to be set to
  attrName
    The name of the attribute being set
  subAttrName
    If setting a property within the attribute's value, the name of the sub-attribute property being set

#### Events inherited from Base:

`destroy, destroyedChange, init, initializedChange,`

#### Events inherited from Plugin.Base:

`hostChange,`

### Configuration Attributes

#### datasource `- Y.DataSource`

Pointer to DataSource instance.

#### initialRequest `- Object`

Request sent to DataSource immediately upon initialization.

#### Configuration attributes inherited from Base:

`destroyed initialized`

#### Configuration attributes inherited from Plugin.Base:

`host`

Copyright © 2011 Yahoo! Inc. All rights reserved.